#!/bin/bash -x

##Support set eip on cvm
##Veriosn:1.0
##Depends:iproute tools
##Provide by QCLOUD 

METADATA=http://metadata.tencentyun.com/meta-data
DEV=eth0
CFG_ETH=/etc/sysconfig/network-scripts/ifcfg-eth0
##SVR_CFG=/etc/rc.d/init.d/network 
RC_LOCAL=/etc/rc.d/rc.local

get_eip()
{
    local eip=$(curl $METADATA/public-ipv4)
    [ $? -eq 0 ] || (echo "get eip failed, pls pass eip." && exit 1)
    echo $eip
}

get_localip()
{
    local local=$(curl $METADATA/local-ipv4)
    echo $local
}

get_gateway()
{
    local gwip=$(route  -n |awk '{if($1=="0.0.0.0")print $2}')
    echo $gwip
}

get_nat_mode()
{
    ##curl $METADATA/network/interfaces/macs/52:54:00:13:5C:6C/local-ipv4s/10.104.187.40/public-ipv4-mode
    echo "nat"
}

set_eip_to_dev()
{
    local eip=$1
    
    ip addr add $eip dev $DEV
    [ $? -eq 0 ] || echo set eip to $DEV failed,maybe $eip already exist on $DEV.
    ##echo "IPADDR111='$eip'" >> $CFG_ETH
}

set_eip_route()
{
    local gwip=$(get_gateway)
    local srcip=$1

    ip route add 10.0.0.0/8 dev $DEV via $gwip
    ip route add 100.64.0.0/10 dev $DEV via $gwip
    ip route add 172.16.0.0/12 dev $DEV via $gwip
    ip route add 192.168.0.0/16 dev $DEV via $gwip
    ip route add 169.254.0.0/16 dev $DEV via $gwip
    ip route add 183.60.83.19 dev $DEV via $gwip
    ip route add 183.60.82.98 dev $DEV via $gwip
    ip route add 255.255.255.255 dev $DEV via $gwip
    ip route del default
    ip route add default via $gwip dev $DEV src $srcip
}

del_default_route()
{
    ip route add 10.0.0.0/8
    ip route add 100.64.0.0/10
    ip route add 172.16.0.0/12
    ip route add 192.168.0.0/16
    ip route add 169.254.0.0/16
    ip route add 183.60.83.19
    ip route add 183.60.82.98
    ip route del 255.255.255.255
    ip route del default
}

set_svr_cfg()
{
    cp $PWD/eip_direct.sh  /etc/rc.d/
    cat $RC_LOCAL |grep "/etc/rc.d/eip_direct.sh"
    [ $? -eq 0 ] && return
    echo "/etc/rc.d/eip_direct.sh install $1"  >>  $RC_LOCAL
       
}

reset_network()
{   
    local eip=$(get_eip)
    ##sed -i '/^IPADDR1.*/d' $CFG_ETH
    sed -i '/eip_direct/d'  $RC_LOCAL
    service network restart
}

case "$1" in
    install)
        if [ $# -eq 3 ];then
            eip=$2
        else
            eip=$(get_eip)
        fi
        set_eip_to_dev $eip
        set_eip_route $eip
        set_svr_cfg $eip
        ;;
    uninstall)
        reset_network
        ;;
    help|*)
    echo $"usage: 
        $0 {install|uninstall|hellp} [eip]}"
    ;;
esac
